using System;
using System.Collections;
// using System.ComponentModel;
using System.Drawing;
// using System.Data;
using System.Windows.Forms;

namespace Bars
{
//	[ToolboxBitmap("Bars.BarGraph.bmp")]
	public class BarGraph : UserControl
	{	
		private int maxLevel = 100;
		private ArrayList bars = new ArrayList();

		/// <summary>
		/// Required designer variable.
		/// </summary>
//		private System.ComponentModel.Container components = null;

		public BarGraph()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
		}
	
		public void addBar(Bar newBar)
		{
			bars.Add(newBar);
		}
	
		public int MaxLevel
		{
			get
			{
				return maxLevel;
			}
			set
			{
				maxLevel = value;
			}
		}

		protected override void OnResize(EventArgs e)
		{
			base.OnResize(e);
			this.Refresh();
		}

		protected override void OnPaint(PaintEventArgs pe) 
		{
			base.OnPaint(pe);
			int numberOfBars = bars.Count;
			if (numberOfBars <= 0) return;

			Brush greyB = new SolidBrush( Color.FromArgb(153,153,153) );
			Graphics g = pe.Graphics;
			int width = this.Width;
			int height = this.Height;

			int barWidth = width/numberOfBars;

			for (int i = 0; i < numberOfBars; i++)
			{	
				Bar bar = (Bar) bars[i];
			
				int x = (barWidth * i);
				int level = bar.Level;
				int y = maxLevel - level;
				y = height * y / maxLevel;
			
				int h = height - y;

				Brush barB = new SolidBrush(bar.Color);
				g.FillRectangle(barB, x, y, barWidth, h); // bar background
			
				if (level > maxLevel)
				{
					g.FillRectangle(greyB, x, 0, barWidth, 10); // bar background
				}

				Pen blackPen = new Pen(Color.Black); 	   // black
				g.DrawRectangle(blackPen, x, y, barWidth, h);  // outline
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
/*		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}
*/
		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// BarGraph
			// 
			this.Name = "BarGraph";
			this.Size = new System.Drawing.Size(104, 104);
		}
		#endregion
	}
}
